#include"CTLVer.h"

//RXgN^(NX̍쐬̏)
CTLVer::CTLVer()
{
	m_CenterPos = D3DXVECTOR2(WIN_WIDTH / 2, WIN_HEIGHT / 2);
	m_Size		= D3DXVECTOR2(10.0f,10.0f);
	m_RotRadian = 0.0f;

	m_UV.cat_x	= 1; m_UV.cat_y = 1;
	m_UV.no_x = 0; m_UV.no_y = 0;
	m_UV.lr_turn_flg = false; m_UV.ud_turn_flg = false;	//UV

	//_̏
	ZeroMemory(m_Ver, sizeof(TLVERTEX)*4);
	for(int i=0; i < 4; i++){
		m_Ver[i].rhw	= 1.0;
		m_Ver[i].x		= m_CenterPos.x + ((i == 1 || i == 2) ? (m_Size.x / 2) : (m_Size.x / (-2)));
		m_Ver[i].y		= m_CenterPos.y + ((i == 2 || i == 3) ? (m_Size.y / 2) : (m_Size.y / (-2)));
		m_Ver[i].z		= 0.0f;
		m_Ver[i].color	= D3DCOLOR_ARGB(255,255,255,255);
		m_Ver[i].tu		= ((i == 1 || i == 2) ? 1.0f : 0.0f);
		m_Ver[i].tv		= ((i == 2 || i == 3) ? 1.0f : 0.0f);
	}
}
//Init@蓮B
void CTLVer::Init()
{
	m_CenterPos = D3DXVECTOR2(WIN_WIDTH / 2, WIN_HEIGHT / 2);
	m_Size		= D3DXVECTOR2(10.0f,10.0f);
	m_RotRadian = 0.0f;
	
	m_UV.cat_x	= 1; m_UV.cat_y = 1;
	m_UV.no_x = 0; m_UV.no_y = 0;
	m_UV.lr_turn_flg = false; m_UV.ud_turn_flg = false;	//UV

	//_̏
	ZeroMemory(m_Ver, sizeof(TLVERTEX)*4);
	for(int i=0; i < 4; i++){
		m_Ver[i].rhw	= 1.0;
		m_Ver[i].x		= m_CenterPos.x + ((i == 1 || i == 2) ? (m_Size.x / 2) : (m_Size.x / (-2)));
		m_Ver[i].y		= m_CenterPos.y + ((i == 2 || i == 3) ? (m_Size.y / 2) : (m_Size.y / (-2)));
		m_Ver[i].z		= 0.0f;
		m_Ver[i].color	= D3DCOLOR_ARGB(255,255,255,255);
		m_Ver[i].tu		= ((i == 1 || i == 2) ? 1.0f : 0.0f);
		m_Ver[i].tv		= ((i == 2 || i == 3) ? 1.0f : 0.0f);
	}

}

//Draw	`B(̓|Sɓ\teNX`)
void CTLVer::Draw(LPDIRECT3DDEVICE9 Dev, LPDIRECT3DTEXTURE9 TexID)
{
	//e|S̒_W̐ݒ
	float tx,ty;			//vZp

	for(int i = 0; i < 4; i++){
		//[JW
		tx = m_Size.x * ((i == 0 || i == 3)? (-0.5f) : 0.5f);
		ty = m_Size.y * ((i == 2 || i == 3)? 0.5f : (-0.5f));
		//XVW = ړ(|S̒SW) + ]()
		m_Ver[i].x = m_CenterPos.x + tx * cos(m_RotRadian) - ty * sin(m_RotRadian);
		m_Ver[i].y = m_CenterPos.y + tx * sin(m_RotRadian) + ty * cos(m_RotRadian);
	}

	Dev->SetRenderState(D3DRS_LIGHTING, FALSE);
	Dev->SetFVF(FVF_TLVERTEX);
	Dev->SetTexture(0,TexID);
	Dev->DrawPrimitiveUP(D3DPT_TRIANGLEFAN, 2, m_Ver, sizeof(TLVERTEX));
}

//ANZ[^()
void CTLVer::SetPos(D3DXVECTOR2 CenterPos)
{
	m_CenterPos = CenterPos;
}

void CTLVer::SetPos_X(float Pos_x)
{
	m_CenterPos.x = Pos_x;
}

void CTLVer::SetPos_Y(float Pos_y)
{
	m_CenterPos.y = Pos_y;
}


void CTLVer::SetSize(D3DXVECTOR2 Size)
{
	m_Size = Size;
}

void CTLVer::SetSize_X(float Size_x)
{
	m_Size.x = Size_x;
}

void CTLVer::SetSize_Y(float Size_y)
{
	m_Size.y = Size_y;
}

void CTLVer::SetRotToRad(float Rad)
{
		m_RotRadian	= Rad;
}

//eNX`Zbg邾ł͂ȂȀɒ_tu,tvݒ肷B
//eNX`͓ɂȂ邱ƂɒӁBꂼCӂł̕͏oȂ(KvoĂ炢B)
bool CTLVer::SetUV(int Cut_X, int Cut_Y, int No_X, int No_Y,  bool LRTurnFlg, bool UDTurnFlg)
{
	//0̏ꍇ0Zh~̂߂ɃG[f
	if((Cut_X == 0) || (Cut_Y == 0)){
		MessageBox(NULL,"CutValue == 0 Error!","SetTLVerUV",MB_OK);
		return false;
	}
	//w肵ԍ葽G[f(Now0琔鎖ɒ)
	if((No_X >= Cut_X)||(No_Y >= Cut_Y)){
		MessageBox(NULL,"CutNo Over CutValue Error!","SetTLVerUV",MB_OK);
		return false;
	}
	float w,h;
	//UV0`1܂ł̒lɕϊKvL邱Ƃɒ
	w = 1.0f / Cut_X;
	h = 1.0f / Cut_Y;

	m_Ver[0].tu = w * No_X;			m_Ver[0].tv = h * No_Y;
	m_Ver[1].tu = w * (No_X + 1);	m_Ver[1].tv = h * No_Y;
	m_Ver[2].tu = w * (No_X + 1);	m_Ver[2].tv = h * (No_Y + 1);
	m_Ver[3].tu = w * No_X;			m_Ver[3].tv = h * (No_Y + 1);

	//]tOȂ甽]̎ނɉtu,tvꂼւ
	if(LRTurnFlg){					//E]
		ValueSwap(&m_Ver[0].tu, &m_Ver[1].tu);				//ev[g֐ɓ삵Ă邩sȂ̂
		ValueSwap(&m_Ver[2].tu, &m_Ver[3].tu);				//u[N|Cgݒu(mFRgƂɍ폜)
	}
	if(UDTurnFlg){					//㉺]
		ValueSwap(&m_Ver[0].tv, &m_Ver[1].tv);
		ValueSwap(&m_Ver[2].tv, &m_Ver[3].tv);
	}
	//ŌɎQƗpUVData\̂ɏi[
	m_UV.cat_x			= Cut_X;	 m_UV.cat_y			= Cut_Y;
	m_UV.no_x			= No_X;		 m_UV.no_y			= No_Y;
	m_UV.lr_turn_flg	= LRTurnFlg; m_UV.ud_turn_flg	= UDTurnFlg;

	return true;
}

bool CTLVer::SetColor(D3DCOLOR Color, int Point)
{
	if(!Point){ 
		MessageBox(NULL, "Point == 0 Error!","SetTLVerColor",MB_OK);
		return false;					//Point0͂Ă炻̏Ŋ֐Eo
	}
	for(int i = 0; i < Point; i++){
		m_Ver[i].color = Color;
	}
	return true;
}

//ANZ[^(o)
D3DXVECTOR2 CTLVer::GetPos(){return m_CenterPos;}
D3DXVECTOR2 CTLVer::GetSize(){return m_Size;}
float		CTLVer::GetRotToRad(){return m_RotRadian;}
UV_DATA		CTLVer::GetUV(){return m_UV;}
