//-----------------------------------------------------------------------------------------------
//Camera.h
//`掞̃JɊւ`Ƃ
//-----------------------------------------------------------------------------------------------
#ifndef _CAMERA_H
#define _CAMERA_H

#include<d3dx9math.h>

//Jp֘A
class CAMINFO{
private:
	float m_Aperture;											//p̎w
	float m_Aspect;												//AXyNg(16:9 = 16/9ƋLq)
	float m_Near;												//near
	float m_Far;												//far
	D3DXVECTOR3 m_Look;											//__J̈ʒu(W)
	D3DXVECTOR3 m_At;											//_(JĂ)W
	D3DXVECTOR3 m_Up;											//(@)

public:

	CAMINFO(){
		m_Look	= D3DXVECTOR3(3.0f, 5.0f, -5.0f);	
		m_At	= D3DXVECTOR3(0.0f, 0.0f, 0.0f);
		m_Up	= D3DXVECTOR3(0.0f, 1.0f, 0.0f);

		m_Aspect = 16/9;

		m_Near	= 1.0f;
		m_Far	= 500.0f;

		m_Aperture = D3DXToRadian(45.0f);
	}

	//ANZ[^()
	void SetAperture(float aperture_value){	//p
		m_Aperture = aperture_value;
	}
	void SetAspect(float aspect_value){		//AXyNg
		m_Aspect = aspect_value;
	}
	void SetNear(float near_value){			//Nearʓ
		m_Near = near_value;
	}
	void SetFar(float far_value){			//Farʓ
		m_Far = far_value;
	}
	void SetLook(D3DXVECTOR3 look_value){	//_(JW)
		m_Look = look_value;
	}
	void SetAt(D3DXVECTOR3 at_value){		//_(Ă)
		m_At = at_value;
	}
	void SetUp(D3DXVECTOR3 up_value){		//(J@)
		m_Up = up_value;
	}

	//o
	float GetAperture(){					//po
		return m_Aperture;
	}
	float GetAspect(){						//AXyNgo
		return m_Aspect;
	}
	float GetNear(){						//Nearʏo
		return m_Near;
	}
	float GetFar(){							//Farʏo
		return m_Far;
	}
	D3DXVECTOR3 GetLook(){					//_(JW)o
		return m_Look;
	}
	D3DXVECTOR3 GetAt(){					//_(Ă)o
		return m_At;
	}
	D3DXVECTOR3 GetUp(){					//(J@o)
		return m_Up;
	}


	~CAMINFO(){}

};



#endif