//----------------------------------------------------------------------------------------
//DebugAxis.h
//3ԏɃfobOp̂R(XYZ)\
//fobOpȂ̂Ńwb_[Ŏg悤ɂB(FȈӖŃRpNgɂ)
//----------------------------------------------------------------------------------------
#ifndef _DEBUG_AXIS_H
#define _DEBUG_AXIS_H

#include<d3dx9.h>

#define FVF_AXIS (D3DFVF_XYZ | D3DFVF_DIFFUSE)

typedef struct _AXISVERTEX
{
	D3DXVECTOR3 position;		//_W
	D3DCOLOR	color;			//_F

}AXISVER,*LPAXISVER;


class DebugAxis
{
private:
	AXISVER		m_Ver[6];		//_
	D3DXMATRIX	m_Wld;			//̃[hs
	float		m_Length;		//̒
public:
	DebugAxis(){
		m_Ver[0].color = D3DCOLOR_ARGB(255,255,0,0);
		m_Ver[1].color = D3DCOLOR_ARGB(255,255,0,0);
		m_Ver[2].color = D3DCOLOR_ARGB(255,0,255,0);
		m_Ver[3].color = D3DCOLOR_ARGB(255,0,255,0);
		m_Ver[4].color = D3DCOLOR_ARGB(255,0,0,255);
		m_Ver[5].color = D3DCOLOR_ARGB(255,0,0,255);

		m_Length = 10.0f;			//̒̓ftHg10.0f

		m_Ver[0].position = D3DXVECTOR3(0,0,0);
		m_Ver[1].position = D3DXVECTOR3(m_Length,0,0);
		m_Ver[2].position = D3DXVECTOR3(0,0,0);
		m_Ver[3].position = D3DXVECTOR3(0,m_Length,0);
		m_Ver[4].position = D3DXVECTOR3(0,0,0);
		m_Ver[5].position = D3DXVECTOR3(0,0,m_Length);
		D3DXMatrixIdentity(&m_Wld);

	}
	void Init(){
		m_Ver[0].color = D3DCOLOR_ARGB(255,255,0,0);
		m_Ver[1].color = D3DCOLOR_ARGB(255,255,0,0);
		m_Ver[2].color = D3DCOLOR_ARGB(255,0,255,0);
		m_Ver[3].color = D3DCOLOR_ARGB(255,0,255,0);
		m_Ver[4].color = D3DCOLOR_ARGB(255,0,0,255);
		m_Ver[5].color = D3DCOLOR_ARGB(255,0,0,255);

		m_Length = 10.0f;

		m_Ver[0].position = D3DXVECTOR3(0,0,0);
		m_Ver[1].position = D3DXVECTOR3(m_Length,0,0);
		m_Ver[2].position = D3DXVECTOR3(0,0,0);
		m_Ver[3].position = D3DXVECTOR3(0,m_Length,0);
		m_Ver[4].position = D3DXVECTOR3(0,0,0);
		m_Ver[5].position = D3DXVECTOR3(0,0,m_Length);
		D3DXMatrixIdentity(&m_Wld);

	}
	void SetLength(float len){			//̒CӂɕύX
		m_Length = len;
	}
	float GetLength(){
		return m_Length;
	}
	void Draw(LPDIRECT3DDEVICE9 Dev){
		m_Ver[1].position = D3DXVECTOR3(m_Length,0,0);
		m_Ver[3].position = D3DXVECTOR3(0,m_Length,0);
		m_Ver[5].position = D3DXVECTOR3(0,0,m_Length);

		Dev->SetTransform(D3DTS_WORLD, &m_Wld);			//[hϊso^
		Dev->SetFVF(FVF_AXIS);							//_tH[}bgݒ
		Dev->SetRenderState(D3DRS_LIGHTING, FALSE);		//CeBOOFFݒ
		Dev->SetTexture(0, NULL);						//eNX`()
		Dev->DrawPrimitiveUP(D3DPT_LINELIST, 3, m_Ver, sizeof(AXISVER));

	}
	//~DebugAxis();
};

#endif