#include "StartScene.h"
#include "CTLver.h"
#include "CTexture.h"
#include "CLVer.h"
#include "Camera.h"
#include "DebugAxis.h"
#include "DebugFloor.h"
#include "Editor.h"

#include "MyInput.h"
//#include "MyFont.h"


extern FRAME				g_FrameNo;
extern LPDIRECT3DDEVICE9	g_pd3ddev;

extern MyInput	*g_pInput;
//extern MyFont	*g_pFont;

//J@\
CAMINFO		g_Cam;					//J
D3DXMATRIX  g_ViewMx, g_ProjMx;		//r[sAˉes

//fobOp(Ōɂ͍폜)--------------------------------
//DebugAxis	g_Axis;
//DebugFloor	g_Floor;

//GfB^@\
Editor g_Editor;

//StarInit  
void StartInit(void)
{

	//3fobO@\-----------------------------------
	//g_Floor.Init();
	//g_Floor.SetFloor(3.0f,3);
	//----------------------------------------------------
	g_Editor.Init();

	g_FrameNo = START_UPDATE;
	OutputDebugString("StartInit֐ʉ߁B\n");
}

//StartWork  WXV
void StartWork(void)
{
	//͉Ȃ
}

//StarUpdate  WȊO̍XV
void StartUpdate(void)
{

	////Jr[Ɋւ鏈-----------------------------
	////r[ϊs̐ݒ(Camera)
	//D3DXMatrixLookAtLH(&g_ViewMx,
	//			&g_Cam.GetLook(),
	//			&g_Cam.GetAt(),
	//			&g_Cam.GetUp());
	//g_pd3ddev->SetTransform(D3DTS_VIEW, &g_ViewMx);
	////ˉeϊs̐ݒ(Projection)
	//D3DXMatrixPerspectiveFovLH(&g_ProjMx,
	//	g_Cam.GetAperture(),
	//	g_Cam.GetAspect(),
	//	g_Cam.GetNear(),
	//	g_Cam.GetFar());
	//g_pd3ddev->SetTransform(D3DTS_PROJECTION, &g_ProjMx);
	////------------------------------------------------------


	//L[͏
	//ʃXN[
	if(g_pInput->KeyHold(DIK_D)){			
		g_Editor.AddScrollVolX(-SCROLL_VOL);
	}else if(g_pInput->KeyHold(DIK_A)){	
		g_Editor.AddScrollVolX(SCROLL_VOL);
	}else{g_Editor.AddScrollVolX(0.0f);}
		if(g_pInput->KeyHold(DIK_W)){
		g_Editor.AddScrollVolY(SCROLL_VOL);
	}else if(g_pInput->KeyHold(DIK_S)){
		g_Editor.AddScrollVolY(-SCROLL_VOL);
	}else{g_Editor.AddScrollVolY(0.0f);}

	//eNX`IDI
	if(g_pInput->KeyPush(DIK_RIGHT)){			
		g_Editor.AddId();
	}else if(g_pInput->KeyPush(DIK_LEFT)){
		g_Editor.SubId();
	}
	//}EX
	//}EXNbNf[^̑yєf
	if(g_pInput->MouseHold(DIM_LEFT)){
		g_Editor.SetChipData(g_pInput->GetCursorX(),g_pInput->GetCursorY());
	}

	//_[h̕ύX
	if(g_pInput->KeyPush(DIK_P)){			
		g_Editor.ChangeRebirthFlg();
		g_Editor.Reset();
	}

	//C[[h̕ύX
	if(g_pInput->KeyPush(DIK_LBRACKET)){
		g_Editor.SubLayerMode();
	}
	if(g_pInput->KeyPush(DIK_RBRACKET)){
		g_Editor.AddLayerMode();
	}

	//o̓Xe[WԍύX(õ͎t@Cɉe)
	if(g_pInput->KeyPush(DIK_COLON)){
		g_Editor.AddMapNo();
	}
	if(g_pInput->KeyPush(DIK_SEMICOLON)){
		g_Editor.SubMapNo();
	}

	//t@C̓o
	if(g_pInput->KeyPush(DIK_K)){
		g_Editor.WriteEditData();
		g_Editor.WriteMapChipData();
	}
	if(g_pInput->KeyPush(DIK_L)){
		g_Editor.ReadEditData();
		g_Editor.Reset();
	}

	g_Editor.UpdateGrid();
	g_Editor.UpdateChipPolygon();
}

//StartDrawBack2D  Ĕw2D`揈(XN[Wn)
void StartDrawBack2D()
{
	//`NA(S^[QbgAZobt@)
	g_pd3ddev->Clear(0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER, D3DCOLOR_ARGB(0x40,0x30,0x50,0x60), 1.0f, 0);

	//`X^[g
	g_pd3ddev->BeginScene();


}

//StartDraw3D  CƂȂ(mȂ)`揈B3D([hWn)gȂ񂾂炢ȂB
void StartDraw3D(void)
{
	g_pd3ddev->Clear(0,NULL, D3DCLEAR_ZBUFFER, 0, 1.0f, 0);		//Zobt@NA

	//fobOp---------------------------------
	//g_Floor.Draw(g_pd3ddev);
	//g_Axis.Draw(g_pd3ddev);
	//-------------------------------------------
}

//StartDrawFront2D  őOʂɂ2D`揈(XN[Wn)
void StartDrawFront2D(void)
{

	g_Editor.DrawMapChip(g_pd3ddev);
	g_Editor.DrawGrid(g_pd3ddev);
	g_Editor.DrawUI(g_pd3ddev);

	//`I
	g_pd3ddev->EndScene();

	//tbv
	g_pd3ddev->Present(NULL, NULL, NULL, NULL);
}

//StartEnd  V[Ỉ
void StartEnd(void)
{
	//ŃV[ɎgpIuWFNg̊Jǉ

	g_FrameNo = START_INIT;

	OutputDebugString("StartEnd֐ʉ\n");
}